`timescale 1ns / 1ps
module nBitAddSub0(a, b, m, c_out, sum);
	input [3:0]	   a, b;
	input          m;
	output         c_out;
	output [3:0]   sum;
	
	wire [2:0] c;

// referenced by name
	FullAdder	FA0(
	   .fa     (a[0]),
	   .fb     (m^b[0]),
	   .fc_in  (m),
	   .fsum   (sum[0]),
	   .fc_out (c[0])
    );

	FullAdder	FA1(
	   .fa     (a[1]),
	   .fb     (m^b[1]),
	   .fc_in  (c[0]),
	   .fsum   (sum[1]),
	   .fc_out (c[1])
    );

	FullAdder	FA2(
	   .fa     (a[2]),
	   .fb     (m^b[2]),
	   .fc_in  (c[1]),
	   .fsum   (sum[2]),
	   .fc_out (c[2])
    );

	FullAdder	FA3(
	   .fa     (a[3]),
	   .fb     (m^b[3]),
	   .fc_in  (c[2]),
	   .fsum   (sum[3]),
	   .fc_out (c_out)
    );
endmodule
	
module FullAdder(fa, fb, fc_in, fsum, fc_out);
	input 			fa, fb, fc_in;
	output			fsum, fc_out;
	
	assign fsum=(~fa&~fb&fc_in)|(~fa&fb&~fc_in)|(fa&~fb&~fc_in)|(fa&fb&fc_in);
	assign fc_out=(fa&fb)|(fa&fc_in)|(fb&fc_in);
endmodule