`timescale 1ns / 1ps
module nBitAddSub0(a, b, m, c_out, sum);
	input [3:0]	   a, b;
	input          m;
	output         c_out;
	output [3:0]   sum;
	
	wire [2:0] c;

// referenced by name
	FullAdder	FA0(a[0], m^b[0], m, sum[0], c[0]);
	FullAdder	FA1(a[1], m^b[1], c[0], sum[1], c[1]);
	FullAdder	FA2(a[2], m^b[2], c[1], sum[2], c[2]);
	FullAdder	FA3(a[3], m^b[3], c[2], sum[3], c[3]);
endmodule
	
module FullAdder(fa, fb, fc_in, fsum, fc_out);
	input 			fa, fb, fc_in;
	output			fsum, fc_out;
	
	assign fsum=(~fa&~fb&fc_in)|(~fa&fb&~fc_in)|(fa&~fb&~fc_in)|(fa&fb&fc_in);
	assign fc_out=(fa&fb)|(fa&fc_in)|(fb&fc_in);
endmodule